import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class AngularV1 extends PApplet {// ------------------------------------------------------------------------------
// AngularV1 - http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// AngularV1.java
// Procedures related to starting up the program and adjusting the settings
// are in this file.
// ------------------------------------------------------------------------------

// ---------------------------------------------------
// SETTINGS
// ---------------------------------------------------

int   SETTINGS_WIDTH                          = 800;
int   SETTINGS_HEIGHT                         = 420;
int   SETTINGS_MAXBULLETS                     = 20;
int   SETTINGS_MAXBOUNCE                      = 2;
int   SETTINGS_MAXRECTANGLES                  = 2;
int   SETTINGS_MAXTRAILS                      = 50;
float SETTINGS_CURSORSPEED                    = 7;
float SETTINGS_COMPUTERSPEED                  = 7;
float SETTINGS_COMPUTERACCELERATION           = 0.3f;
float SETTINGS_CURSORSIZE                     = 17;
float SETTINGS_CURSORANGLE                    = 45;
float SETTINGS_BULLETSPEED                    = 20;
float SETTINGS_BOUNCECONSTANT                 = 1;
float SETTINGS_RATEOFFIRECOMPUTER             = 0.1f;
float SETTINGS_RATEOFFIREHUMAN                = 0.1f;
float SETTINGS_FRAMERATE                      = 30;
float SETTINGS_BULLETSPREAD                   = 2;
float SETTINGS_AIMINGCIRCLE                   = 35;
float SETTINGS_BULLETRECTANGLEPOWER           = 10;
float SETTINGS_BULLETCURSORPOWER              = 5;
float SETTINGS_BULLETLENGTH                   = 30;
float SETTINGS_XSHADOWDISTANCE                = 0;
float SETTINGS_YSHADOWDISTANCE                = 10;
float SETTINGS_SHIELDDECAY                    = 0.4f;
float SETTINGS_SHIELDRADIUS                   = 25;
float SETTINGS_SHIELDSPEEDK                   = 0.4f;
float SETTINGS_CHARGEDISCHARGERATIO           = 20;
float SETTINGS_SHAKEAMOUNT                    = 5;
float SETTINGS_COMPUTERROTATESPEED            = 10;
float SETTINGS_FUTURE                         = 15;
float SETTINGS_PADDING                        = 20;

// ---------------------------------------------------
// STATS
// ---------------------------------------------------

int STATS_CURRENTBULLET;
int STATS_CURRENTTRAIL;
int STATS_MODETIME;
int STATS_FRAME;
float STATS_HIDEX;
float STATS_HIDEY;
float STATS_BACKGROUNDOPACITY;
boolean STATS_ACTIVE = false;
String STATS_GAME;

// ---------------------------------------------------
// ARRAYS
// ---------------------------------------------------

Ray RAY                                       = new Ray();
Cursor[] CURSORS                              = new Cursor[2];
Bullet[] BULLETS                              = new Bullet[SETTINGS_MAXBULLETS];
Trail[] TRAILS                                = new Trail[SETTINGS_MAXTRAILS];
Rectangle[] RECTANGLES                        = new Rectangle[SETTINGS_MAXRECTANGLES];

// ---------------------------------------------------
// INTERFACE
// ---------------------------------------------------

PFont font;

public void setup()
{
  size(800,420);
  framerate(SETTINGS_FRAMERATE);
  smooth();
  reset();

  font = loadFont("Verdana-Bold-14.vlw");
  textFont(font, 14);
}

public void reset()
{
  CURSORS[0] = new Cursor(700,height/2,"human");
  CURSORS[1] = new Cursor(100,height/2,"computer");
  CURSORS[0].calculatePoints();
  CURSORS[1].calculatePoints();
  RECTANGLES[0] = new Rectangle(200, height/2, 30, 175, 0, 0.95f);
  RECTANGLES[1] = new Rectangle(600, height/2, 30, 175, 0, 0.95f);
  
  for ( int i=0; i<SETTINGS_MAXBULLETS; i++ )
  {
    BULLETS[i] = new Bullet(-10,-10,0,0,0,0);
  }
  
  for ( int i=0; i<SETTINGS_MAXTRAILS; i++ )
  {
    TRAILS[i] = new Trail(-10,-10,-10,-10);
  }
  
  STATS_CURRENTBULLET                       = 0;
  STATS_CURRENTTRAIL                        = 0;
  STATS_MODETIME                            = 0;
  STATS_FRAME                               = 0;
  STATS_HIDEX                               = 100;
  STATS_HIDEY                               = SETTINGS_HEIGHT/2;
  STATS_BACKGROUNDOPACITY                   = 255;
  STATS_GAME                                = "under";
}

public void draw()
{
  checkKeyboard();
  updateBullets();
  updateRectangles();
  updateTrails();
  updateRay();
  if ( STATS_ACTIVE )
  {
    updateCursors();
    
    if ( STATS_GAME == "under" )
    {
      STATS_FRAME++;
    }
  }
  drawBackground();
  drawBullets();
  drawRectangles();
  drawTrails();
  drawCursors();
  //drawRay();
  drawGameOver();
}

// ---------------------------------------------------
// EFFECTS
// ---------------------------------------------------

public void blur( float O )
{
  STATS_BACKGROUNDOPACITY = O;
}

public void shake()
{
  translate(random(-SETTINGS_SHAKEAMOUNT,SETTINGS_SHAKEAMOUNT),random(-SETTINGS_SHAKEAMOUNT,SETTINGS_SHAKEAMOUNT));
}

// ---------------------------------------------------
// CALCULATION
// ---------------------------------------------------

public void updateRay()
{
  RAY.update();
}

public void updateRectangles()
{
  for ( int i=0; i<SETTINGS_MAXRECTANGLES; i++ )
  {
    RECTANGLES[i].update();
  }
}

public void updateBullets()
{
  for ( int i=0; i<SETTINGS_MAXBULLETS; i++ )
  {
    BULLETS[i].update();
  }
}

public void updateTrails()
{
  for ( int i=0; i<SETTINGS_MAXTRAILS; i++ )
  {
    TRAILS[i].update();
  }
}

public void updateCursors()
{
  CURSORS[0].update();
  CURSORS[1].update();
}

// ---------------------------------------------------
// DRAWING
// ---------------------------------------------------

public void drawGameOver()
{
  if ( STATS_GAME == "over" )
  {
    fill(255,255,255,230);
    stroke(255,255,255);
    rect(0,0,width,height);
    fill(0,0,0);
    textAlign(CENTER);
    text("GAME OVER",400,200);
    fill(50,50,50);
    if ( CURSORS[0].h == 0 )
    {
      text("You were annihilated in " + PApplet.toInt(STATS_FRAME/SETTINGS_FRAMERATE) + " seconds",400,230);
    }
    else
    {
      text("You destroyed the guru in " + PApplet.toInt(STATS_FRAME/SETTINGS_FRAMERATE) + " seconds",400,230);
    }
    text("Press space to try again",400,250);
  }
}

public void drawBullets()
{
  for ( int i=0; i<SETTINGS_MAXBULLETS; i++ )
  {
    BULLETS[i].display();
  }
}

public void drawRay()
{
  RAY.display();
}

public void drawRectangles()
{
  for ( int i=0; i<SETTINGS_MAXRECTANGLES; i++ )
  {
    RECTANGLES[i].display();
  }
}

public void drawTrails()
{
  for ( int i=0; i<SETTINGS_MAXTRAILS; i++ )
  {
    TRAILS[i].display();
  }
}

public void drawCursors()
{
  CURSORS[0].display();
  CURSORS[1].display();
}

public void drawBackground()
{
  if ( STATS_BACKGROUNDOPACITY < 240 )
  {
    STATS_BACKGROUNDOPACITY += ( 255 - STATS_BACKGROUNDOPACITY )/5;
    stroke(255,255,255);
    fill(255,255,255,STATS_BACKGROUNDOPACITY);
    rect(0,0,width,height);
  }
  else
  {
    background(255,255,255);
  }
}

// ---------------------------------------------------
// INPUT
// ---------------------------------------------------

public void mousePressed()
{
  if ( !STATS_ACTIVE ) 
  {
    noCursor(); 
    STATS_ACTIVE = true; 
  }
  else
  {
    CURSORS[0].startShoot();
  }
}

public void mouseReleased()
{
  CURSORS[0].stopShoot();
}

public void checkKeyboard()
{
  if ( keyPressed )
  {
    if ( keyCode == SHIFT )
    {
      CURSORS[0].startShield();
    }
    if ( key == ' ' )
    {
      reset();
    }     
  }
}

// ------------------------------------------------------------------------------
// AngularV1 - http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Bullet.java
// the bullets that the agents shoot
// ------------------------------------------------------------------------------

class Bullet
{
  int bounce;
  float x;
  float y;
  float vx;
  float vy;
  float r;
  float g;
  float b;
  boolean dead;
  
  Bullet( float X, float Y, float T, float R, float G, float B )
  {
    bounce = 0;
    x = X;
    y = Y;
    vx = SETTINGS_BULLETSPEED*cos(T);
    vy = SETTINGS_BULLETSPEED*sin(T);
    r = R;
    g = G;
    b = B;
  }
  
  public void update()
  {
    if ( ! dead )
    {
      bounce();
      collide();
      move();
    }
  }
  
  public void bounce()
  {
    if ( ( y + vy > height || y + vy < 0 ) && bounce < SETTINGS_MAXBOUNCE )
    {
      vy *= -SETTINGS_BOUNCECONSTANT;
      bounce++;
    }
    if ( ( x + vx > width || x + vx < 0 ) && bounce < SETTINGS_MAXBOUNCE )
    {
      vx *= -SETTINGS_BOUNCECONSTANT;
      bounce++;
    }
  }
  
  public void collide()
  {
    for ( int i=0; i<SETTINGS_MAXRECTANGLES; i++ )
    {
      float x2 = RECTANGLES[i].cx;
      float y2 = RECTANGLES[i].cy;
      float a = RECTANGLES[i].a;
      float b = RECTANGLES[i].b;
        
      float deltax = x2 - x;
      float deltay = y2 - y;
      float deltad = sqrt(pow(deltax,2)+pow(deltay,2));
         
      if ( deltad < sqrt(pow(a/2,2)+pow(b/2,2)) )
      {
        if ( RECTANGLES[i].checkPos(x,y) )
        {
          float theta = atan2(vy,vx);
          float fx = SETTINGS_BULLETRECTANGLEPOWER*cos(theta);
          float fy = SETTINGS_BULLETRECTANGLEPOWER*sin(theta);
      
          RECTANGLES[i].exertForce(fx,fy,x-x2,y-y2);
          dead = true;
        }
      }
    } 
    for ( int i=0; i<2; i++ )
    {
      float theta = CURSORS[i].t;
      float deltax = CURSORS[i].x - SETTINGS_CURSORSIZE*cos(theta) - x;
      float deltay = CURSORS[i].y - SETTINGS_CURSORSIZE*sin(theta) - y;
      float deltad = sqrt(pow(deltax,2)+pow(deltay,2));
      
      float fdeltax = deltax - vx;
      float fdeltay = deltay - vy;
      float fdeltad = sqrt(pow(fdeltax,2)+pow(fdeltay,2));
      
      if ( fdeltad < CURSORS[i].sr && CURSORS[i].sr > 5 )
      {
        float ffdeltax = fdeltax - vx;
        float ffdeltay = fdeltay - vy;
        float ffdeltad = sqrt(pow(ffdeltax,2)+pow(ffdeltay,2));
      
        if ( ffdeltad < deltad )
        {
          float mtheta = atan2(-deltay,-deltax);
          float ctheta = atan2(-vy,-vx);
          float ftheta = mtheta + ( mtheta - ctheta );
        
          vx = SETTINGS_BULLETSPEED*cos(ftheta);
          vy = SETTINGS_BULLETSPEED*sin(ftheta);
          
          bounce++;
          STATS_MODETIME = 0;
        }
      }
      else if ( deltad < SETTINGS_CURSORSIZE )
      {
        CURSORS[i].reduceHealth(SETTINGS_BULLETCURSORPOWER);
        blur(50);
        shake();
        dead = true;
      }
    }      
  }
  
  public void move()
  {
    x += vx;
    y += vy;
  }
  
  public void display()
  {
    if ( !dead )
    {
      float theta = atan2(vy,vx);
     
      stroke(r,g,b);
      strokeWeight(2);
      line(x,y,x-SETTINGS_BULLETLENGTH*cos(theta)/2, y-SETTINGS_BULLETLENGTH*sin(theta)/2);
    }
  }
}

// ------------------------------------------------------------------------------
// AngularV1 - http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Cursor.java
// The agents, good or bad.
// ------------------------------------------------------------------------------

class Cursor
{
  String type;
  float framecount;
  float x,y;
  float tx,ty;
  float vx,vy;
  float vd;
  float sd,st;
  float t;
  float h;
  float x1,y1,x2,y2;
  float px,py,px1,py1,px2,py2;
  float sr;
  float stheta;
  float sx1,sy1,sx2,sy2,sx3,sy3;
  float cx,cy;
  float k;
  boolean aim;
  boolean shoot;
  String reflect;
  String mode;

  Cursor( float X, float Y, String Type )
  {
    x = tx = px = X;
    y = ty = py = Y;
    t = 0;
    type = Type;
    h = 100;
    stheta = 0;
    k = 1;
    mode = "pursuit";
  }
  
  public void update()
  {   
    if ( type == "human" )
    {
      setTargetHuman();
      moveHuman();
      if ( shoot && PApplet.toInt(framecount*SETTINGS_RATEOFFIREHUMAN) == framecount*SETTINGS_RATEOFFIREHUMAN) { primaryShoot(); }
    }
    else
    {
       think();
       STATS_MODETIME++;
       if ( shoot && PApplet.toInt(framecount*SETTINGS_RATEOFFIRECOMPUTER) == framecount*SETTINGS_RATEOFFIRECOMPUTER) { primaryShoot(); }
    }   

    calculatePoints();
    calculateShield();
    framecount++;
    makeTrail();
    px = x;
    py = y;
    px1 = x1;
    py1 = y1;
    px2 = x2;
    py2 = y2;
  }
  
  // ---------------------------------------------------
  // Human Cursor Functions
  // ---------------------------------------------------
  
  public void setTargetHuman()
  {   
    float deltax = mouseX-x;
    float deltay = mouseY-y;
    float deltad = sqrt(pow(deltax,2)+pow(deltay,2));
    float theta = atan2(deltay,deltax);
    t = theta;
    
    if ( deltad > SETTINGS_AIMINGCIRCLE+5 )
    {
      tx = mouseX - SETTINGS_AIMINGCIRCLE*cos(theta);
      ty = mouseY - SETTINGS_AIMINGCIRCLE*sin(theta);
      aim = false;
    }
    else
    {
      tx = x;
      ty = y;
      aim = true;
    }
  } 
  
  public void moveHuman()
  {
    float deltax = tx-x;
    float deltay = ty-y;
    
    vx = deltax*SETTINGS_CURSORSPEED/100;
    vy = deltay*SETTINGS_CURSORSPEED/100;
    
    float vd = sqrt(pow(vx,2)+pow(vy,2));
    
    if ( vd > k*SETTINGS_CURSORSPEED )
    {
      float theta = atan2(vy,vx);
      vx = k*SETTINGS_CURSORSPEED*cos(theta);
      vy = k*SETTINGS_CURSORSPEED*sin(theta);
    }
    
    x += vx;
    y += vy;
  }
   
  // ---------------------------------------------------
  // Computer Cursor Functions
  // ---------------------------------------------------
  
  public void think()
  {
    if ( mode == "pursuit" )
    {   
      if ( RAY.crossed )
      {
        if ( shoot ) { stopShoot(); }
      }
      else
      {
        if ( !shoot ) { startShoot(); }
      }
      
      aimStraightComputer();
      moveComputer();
      if ( STATS_MODETIME > 3*SETTINGS_FRAMERATE || sqrt(pow(CURSORS[0].x - x,2)+pow(CURSORS[0].y - y,2)) < 50)
      {
        changeMode("hide");
      }
    }
    
    if ( mode == "turret" )
    {
      if ( RAY.crossed )
      {
        aimReflectComputer();
      }
      else
      {
        aimStraightComputer();
      }
      
      if ( !shoot ) { startShoot(); }
      haltComputer();
      if ( STATS_MODETIME > 5*SETTINGS_FRAMERATE )
      {
        changeMode("pursuit");
      }
    }
    
    if ( mode == "hide" )
    {
      if ( shoot ) { stopShoot(); }
      runComputer();  
    }
    
    if ( mode == "rest" )
    {
      if ( !RAY.crossed )
      {
        changeMode("turret");
      }
      aimStraightComputer();
      if ( shoot ) { stopShoot(); }
      haltComputer();
      if ( STATS_MODETIME > 1*SETTINGS_FRAMERATE )
      {
        changeMode("turret");
      }
    }
    
    if ( mode == "shield" )
    {
      if ( shoot ) { stopShoot(); }
      if ( STATS_MODETIME < SETTINGS_FRAMERATE )
      {
        startShield();
      }
      else
      {
        if ( sqrt(pow(CURSORS[0].x - x,2)+pow(CURSORS[0].y - y,2)) > 100 )
        {
          changeMode("rest");
        }
        else
        {
          changeMode("pursuit");
        }
      }
      aimStraightComputer();
      haltComputer();
    }
  }
  
  public void changeMode( String Mode )
  {
    STATS_MODETIME = 0;
    mode = Mode;
  }
  
  public void runComputer()
  {
    if ( CURSORS[0].x > 3*width/4 && !RAY.crossed )
    {
      STATS_HIDEX = 100;
      STATS_HIDEY = height/2+random(-100,100);
    }
    else if ( CURSORS[0].x < width/4 && !RAY.crossed)
    {
      STATS_HIDEX = 700;
      STATS_HIDEY = height/2+random(-100,100);
    }
    
    if ( abs(STATS_HIDEX-x) > 20 || abs(STATS_HIDEY-y) > 20 )
    {
      setSteer(STATS_HIDEX, STATS_HIDEY);  
      moveComputer();
    }
    else
    {
      changeMode("rest");
    }
  }
  
  public void haltComputer()
  {
    float sx = sd*cos(st+t);
    float sy = sd*sin(st+t);
    
    vx = vd*cos(t);
    vy = vd*sin(t);
    
    vx += sx;
    vy += sy;
    
    vd = sqrt(pow(vx,2)+pow(vy,2));
    t = atan2(vy,vx);
    
    vd = 1;
  }
  
  public void moveComputer()
  {
    float sx = sd*cos(st+t);
    float sy = sd*sin(st+t);
    
    vx = vd*cos(t);
    vy = vd*sin(t);
    
    vx += sx;
    vy += sy;
    
    vd = sqrt(pow(vx,2)+pow(vy,2));
    t = atan2(vy,vx);
    
    if ( vd < k*SETTINGS_COMPUTERSPEED )
    {
      vd += SETTINGS_COMPUTERACCELERATION;
    }
    
    if ( vd > k*SETTINGS_COMPUTERSPEED )
    {
      vd = k*SETTINGS_COMPUTERSPEED;
      vx = vd*cos(t);
      vy = vd*sin(t);
    }
    
    x += vx;
    y += vy;
  }
  
  public void aimStraightComputer()
  {
    float deltax = CURSORS[0].x - x;
    float deltay = CURSORS[0].y - y;
    float deltad = sqrt(pow(deltax,2)+pow(deltay,2));
    float timeToCollision = deltad/SETTINGS_BULLETSPEED;
    float deltaxf = CURSORS[0].x + CURSORS[0].vx*timeToCollision - x;
    float deltayf = CURSORS[0].y + CURSORS[0].vy*timeToCollision - y;
    float deltadf = sqrt(pow(deltaxf,2)+pow(deltayf,2));
    float timeToCollisionF = deltadf/SETTINGS_BULLETSPEED;
    float xTarget = CURSORS[0].cx + CURSORS[0].vx*timeToCollisionF;
    float yTarget = CURSORS[0].cy + CURSORS[0].vy*timeToCollisionF;
    
    setSteer(xTarget, yTarget);
  }
  
  public void aimReflectComputer()
  {
    float deltax = CURSORS[0].cx - x;
    float deltay = CURSORS[0].cy - y;
    float dx;
    float xTarget;
    float yTarget;
    
    if ( CURSORS[0].y < height/4 )
    {
      reflect = "top";
    }
    else if ( CURSORS[0].y > 3*height/4 )
    {
      reflect = "bottom";
    }
      
    if ( reflect == "top" )
    {
      dx = deltax/(1+y/CURSORS[0].cy);
      xTarget = CURSORS[0].cx - dx;
      yTarget = 0;
    }
    else
    {
      dx = deltax/(1+(height-y)/(height-CURSORS[0].cy));
      xTarget = CURSORS[0].cx - dx;
      yTarget = height;
    }
    
    setSteer(xTarget, yTarget);
  }
  
  public void setSteer( float X, float Y )
  {
    if ( isLeft(x,y,x+vx,y+vy,X,Y) > 0 )
    {
      st = PI/2;
    }
    else
    {
      st = -PI/2;
    }
    
    float d = sqrt(pow(X-x,2)+pow(Y-y,2));
    float xf = x + d*cos(t);
    float yf = y + d*sin(t);
    
    sd = sqrt(pow(X-xf,2)+pow(Y-yf,2))*SETTINGS_COMPUTERROTATESPEED/(10*d);
  }
  
  public float isLeft( float x1, float y1, float x2, float y2, float x3, float y3 )
  {
    return (x2 - x1)*(y3 - y1) - (x3 - x1)*(y2 - y1);
  }
  
  // ---------------------------------------------------
  // Common Functions
  // ---------------------------------------------------
  
  public void die()
  {
    vx = 0;
    vy = 0.5f;
  }
  
  public void calculatePoints()
  {
    x1 = SETTINGS_CURSORSIZE*cos(t-radians(SETTINGS_CURSORANGLE/2));
    y1 = SETTINGS_CURSORSIZE*sin(t-radians(SETTINGS_CURSORANGLE/2));
    x2 = SETTINGS_CURSORSIZE*cos(t+radians(SETTINGS_CURSORANGLE/2));
    y2 = SETTINGS_CURSORSIZE*sin(t+radians(SETTINGS_CURSORANGLE/2));
    cx = x-SETTINGS_CURSORSIZE*cos(t)/2;
    cy = y-SETTINGS_CURSORSIZE*sin(t)/2;
  }
  
  public void calculateShield()
  {
    if ( sr - SETTINGS_SHIELDDECAY >= 0 )
    {
      sr -= SETTINGS_SHIELDDECAY;
    }
    if ( k + SETTINGS_SHIELDDECAY/SETTINGS_SHIELDRADIUS < 1 )
    {
      k += SETTINGS_SHIELDDECAY/SETTINGS_SHIELDRADIUS;
    }
    
    stheta += radians(15);
    
    sx1 = x - SETTINGS_CURSORSIZE*cos(t)/2 + sr*cos(stheta);
    sy1 = y - SETTINGS_CURSORSIZE*sin(t)/2 + sr*sin(stheta);
    sx2 = x - SETTINGS_CURSORSIZE*cos(t)/2 + sr*cos(stheta+2*PI/3);
    sy2 = y - SETTINGS_CURSORSIZE*sin(t)/2 + sr*sin(stheta+2*PI/3);
    sx3 = x - SETTINGS_CURSORSIZE*cos(t)/2 + sr*cos(stheta+4*PI/3);
    sy3 = y - SETTINGS_CURSORSIZE*sin(t)/2 + sr*sin(stheta+4*PI/3);
  }
  
  public void primaryShoot()
  {
    float r,g,b;
    
    if ( type == "human" ) 
    { 
      r = 253;
      g = 33;
      b = 33;
    }
    else
    {
      r = 253;
      g = 157;
      b = 33;
    }
    
    BULLETS[STATS_CURRENTBULLET] = new Bullet(x+10*cos(t),y+10*sin(t),t+radians(random(-SETTINGS_BULLETSPREAD/2,SETTINGS_BULLETSPREAD/2)),r,g,b);
    
    STATS_CURRENTBULLET++;
    
    if ( STATS_CURRENTBULLET == SETTINGS_MAXBULLETS )
    {
      STATS_CURRENTBULLET = 0;
    }
  }
  
  public void makeTrail()
  {
    TRAILS[STATS_CURRENTTRAIL] = new Trail(x-x1,y-y1,px-px1,py-py1);
    STATS_CURRENTTRAIL++;
    TRAILS[STATS_CURRENTTRAIL] = new Trail(x-x2,y-y2,px-px2,py-py2);
    STATS_CURRENTTRAIL++;
    
    if ( STATS_CURRENTTRAIL == SETTINGS_MAXTRAILS )
    {
      STATS_CURRENTTRAIL = 0;
    }
  }
  
  public void startShoot()
  {
    if ( sr < 5 )
    {
      shoot = true;
    }

    framecount = 0;
  }
  
  public void stopShoot()
  {
    shoot = false;
  }
  
  public void startShield()
  {
    if ( sr  + SETTINGS_SHIELDDECAY*SETTINGS_CHARGEDISCHARGERATIO < SETTINGS_SHIELDRADIUS )
    {
      sr += SETTINGS_SHIELDDECAY*SETTINGS_CHARGEDISCHARGERATIO;
    }
    else
    {
      sr = SETTINGS_SHIELDRADIUS;
    }
    
    shoot = false;
    k = 1 - (1-SETTINGS_SHIELDSPEEDK)*sr/SETTINGS_SHIELDRADIUS;
  }
  
  public void reduceHealth( float H )
  {
    if ( h - H > 0 )
    {
      h -= H;
      if ( mode != "shield" ) { changeMode("shield"); }
    }
    else
    {
      h = 0;
      STATS_GAME = "over";
    }
  }
  
  // ---------------------------------------------------
  // Draw Functions
  // ---------------------------------------------------

  public void display()
  {
    drawShadow();
    drawShield(); 
    drawTarget();
    drawAfterBurner();
    drawCursor();
    drawHealth();
  }
  
  public void drawTarget()
  {
    if ( type == "human" )
    {
      if ( aim && sr < 5 )
      {
        stroke(50,200,50,100);
        strokeWeight(1);
        line(x,y,mouseX,mouseY);
        
        stroke(50,200,50);
        strokeWeight(3);
        point(mouseX,mouseY);
      }
      
      stroke(200,50,50);
      strokeWeight(4);
      point(tx,ty);
    }
  }
  
  public void drawCursor()
  {  
    stroke(0,0,0);
    strokeWeight(2);
    fill(255,255,255);
    
    beginShape(POLYGON);
    vertex(x,y);
    vertex(x-x1,y-y1);
    vertex(x-x2,y-y2);
    vertex(x,y);
    endShape();
  }
  
  public void drawShadow()
  {  
    stroke(0,0,0,10);
    strokeWeight(2);
    fill(0,0,0,40);
    
    beginShape(POLYGON);
    vertex(x+SETTINGS_XSHADOWDISTANCE,y+SETTINGS_YSHADOWDISTANCE);
    vertex(x-x1+SETTINGS_XSHADOWDISTANCE,y-y1+SETTINGS_YSHADOWDISTANCE);
    vertex(x-x2+SETTINGS_XSHADOWDISTANCE,y-y2+SETTINGS_YSHADOWDISTANCE);
    vertex(x+SETTINGS_XSHADOWDISTANCE,y+SETTINGS_YSHADOWDISTANCE);
    endShape();
  }
  
  public void drawAfterBurner()
  {
    float offset = radians(SETTINGS_CURSORANGLE/3);
    float x1 = x-0.9f*SETTINGS_CURSORSIZE*cos(t+offset);
    float y1 = y-0.9f*SETTINGS_CURSORSIZE*sin(t+offset);
    float x2 = x-0.9f*SETTINGS_CURSORSIZE*cos(t-offset);
    float y2 = y-0.9f*SETTINGS_CURSORSIZE*sin(t-offset);
    float r = sqrt(pow(vx,2)+pow(vy,2))/5;
    float x3 = x-r*SETTINGS_CURSORSIZE*cos(t);
    float y3 = y-r*SETTINGS_CURSORSIZE*sin(t);
    
    strokeWeight(2);
    stroke(234,78,17);
    fill(234,175,17);
    beginShape(POLYGON);
    vertex(x1,y1);
    vertex(x2,y2);
    vertex(x3,y3);
    vertex(x1,y1);
    endShape();
  }
  
  public void drawHealth()
  {
    float xh1 = (100-h)/100*x1;
    float yh1 = (100-h)/100*y1;
    float xh2 = (100-h)/100*x2;
    float yh2 = (100-h)/100*y2;
    
    stroke(0,0,0);
    strokeWeight(1);
    fill(255,50,50);
    
    beginShape(POLYGON);
    vertex(x,y);
    vertex(x-xh1,y-yh1);
    vertex(x-xh2,y-yh2);
    vertex(x,y);
    endShape();
  }
  
  public void drawShield()
  {
    if ( sr > 5 ) 
    { 
      stroke(202,36,169,50);
      fill(255,255,255,0);
      strokeWeight(2);
      ellipse(cx,cy,2*sr,2*sr);
      stroke(41,88,136);
      strokeWeight(4);
      point(sx1,sy1);
      point(sx2,sy2);
      point(sx3,sy3);
    }
  }
}

// ------------------------------------------------------------------------------
// AngularV1 - http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Ray.java
// Something the enemy AI uses to aim. It tells the agent if it has a clear shot.
// ------------------------------------------------------------------------------

class Ray
{
  int num_points = 50;
  boolean crossed;
  Point[] Points = new Point[num_points];
  
  Ray()
  {
    for ( int i=0; i<num_points; i++ )
    {
      Points[i] = new Point();
    }
  }
  
  public void update()
  {
    crossed = false;
    
    float x1 = CURSORS[0].x;
    float y1 = CURSORS[0].y;
    float x2 = CURSORS[1].x;
    float y2 = CURSORS[1].y;
    
    for ( int i=0; i<num_points; i++ )
    {
      Points[i].update(x1 + (x2-x1)*i/num_points,y1 + (y2-y1)*i/num_points);
      for ( int j=0; j<SETTINGS_MAXRECTANGLES; j++ )
      {
        if ( RECTANGLES[j].checkPosApprox(Points[i].x, Points[i].y) )
        {
          crossed = true;
        }
      }
    }
  }
  
  public void display()
  {
    stroke(0,0,0,50);
    strokeWeight(3);
    
    for ( int i=0; i<num_points; i++ )
    {
      point(Points[i].x, Points[i].y);
    }
  }
}

class Point
{
  float x;
  float y;
  
  Point()
  {
    x = X;
    y = Y;
  }
  
  public void update( float X, float Y )
  {
    x = X;
    y = Y;
  }
}

// ------------------------------------------------------------------------------
// AngularV1 - http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Square.java
// The obstacles that have physical properties... yummm...
// ------------------------------------------------------------------------------

class Rectangle
{
  float i;
  float w;
  float m;
  float a;
  float b;
  float vx;
  float vy;
  float cx;
  float cy;
  float x1, y1, x2, y2, x3, y3, x4, y4;
  float rdamp;
  float vdamp;
  float omega;
  
  Rectangle(float CX, float CY, float A, float B, float VDAMP, float RDAMP )
  {
    cx = CX;
    cy = CY;
    a = A;
    b = B;
    omega = 0;
    m = 10;
    w = 0;
    i = m*(pow(a,2) + pow(b,2))/12;
    vdamp = VDAMP;
    rdamp = RDAMP;
  }
  
  public void update()
  {
    moveBox();
    rotateBox();
  }
  
  public void exertForce(float FX, float FY, float X, float Y)
  {
    float l = sqrt(pow(FX,2)+pow(FY,2))*sqrt(pow(X,2)+pow(Y,2))*sin(atan2(FY,FX)-atan2(Y,X));
      
    vx += FX/m;
    vy += FY/m;
    w  += -l/i;
  }
  
  public void rotateBox()
  {
    omega += w;
    w *= rdamp;
    
    float cw = cos(omega)*a/2;
    float sw = sin(omega)*a/2;
    float ch = cos(omega)*b/2;
    float sh = sin(omega)*b/2;
    
    x1 = + cw + sh;
    y1 = - sw + ch;
    x2 = + cw - sh;
    y2 = - sw - ch;
    x3 = - cw - sh;
    y3 = + sw - ch;
    x4 = - cw + sh;
    y4 = + sw + ch;    
  }
  
  public void moveBox()
  {
    vx *= vdamp;
    vy *= vdamp;
    
    cx += vx;
    cy += vy;
  }
  
  public boolean checkPos( float X, float Y )
  {
    float mx = cos(-omega)*(X-cx)+sin(-omega)*(Y-cy);
    float my = cos(-omega)*(Y-cy)-sin(-omega)*(X-cx);
     
    if ( abs(mx) < a/2 && abs(my) < b/2 )
    {
      return true;     
    }
    else
    {
      return false;
    }
  }
  
  public boolean checkPosApprox( float X, float Y )
  {
    float mx = cos(-omega)*(X-cx)+sin(-omega)*(Y-cy);
    float my = cos(-omega)*(Y-cy)-sin(-omega)*(X-cx);
     
    if ( abs(mx) - 5 < a/2 && abs(my) - 5 < b/2 )
    {
      return true;     
    }
    else
    {
      return false;
    }
  }
  
  public void display()
  {
    stroke(58,117,159);
    fill(231,238,243);
    strokeWeight(1);
    beginShape(POLYGON); 
    vertex(cx+x1,cy+y1);
    vertex(cx+x2,cy+y2);
    vertex(cx+x3,cy+y3);
    vertex(cx+x4,cy+y4);
    endShape(); 
    strokeWeight(3);
    point(cx,cy);
  }
}

// ------------------------------------------------------------------------------
// AngularV1 - http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Trail.java
// The cursors' trails.
// ------------------------------------------------------------------------------

class Trail
{
  float x1;
  float y1;
  float x2;
  float y2;
  float a;
  
  Trail( float X1, float Y1, float X2, float Y2 )
  {
    x1 = X1;
    y1 = Y1;
    x2 = X2;
    y2 = Y2;
    a = 250;
  }
  
  public void update()
  {
    if ( a - 500/SETTINGS_MAXTRAILS >= 0 )
    {
      a -= 500/SETTINGS_MAXTRAILS;
    }  
  }
  
  public void display()
  {
    stroke(200,200,200,a);
    strokeWeight(1);
    line(x1,y1,x2,y2);
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "AngularV1" });}}