// ------------------------------------------------------------------------------
// AngularV1 - http://www.arkitus.com
// Copyright (C) 2006  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Ray.java
// Something the enemy AI uses to aim. It tells the agent if it has a clear shot.
// ------------------------------------------------------------------------------

class Ray
{
  int num_points = 50;
  boolean crossed;
  Point[] Points = new Point[num_points];
  
  Ray()
  {
    for ( int i=0; i<num_points; i++ )
    {
      Points[i] = new Point();
    }
  }
  
  void update()
  {
    crossed = false;
    
    float x1 = CURSORS[0].x;
    float y1 = CURSORS[0].y;
    float x2 = CURSORS[1].x;
    float y2 = CURSORS[1].y;
    
    for ( int i=0; i<num_points; i++ )
    {
      Points[i].update(x1 + (x2-x1)*i/num_points,y1 + (y2-y1)*i/num_points);
      for ( int j=0; j<SETTINGS_MAXRECTANGLES; j++ )
      {
        if ( RECTANGLES[j].checkPosApprox(Points[i].x, Points[i].y) )
        {
          crossed = true;
        }
      }
    }
  }
  
  void display()
  {
    stroke(0,0,0,50);
    strokeWeight(3);
    
    for ( int i=0; i<num_points; i++ )
    {
      point(Points[i].x, Points[i].y);
    }
  }
}

class Point
{
  float x;
  float y;
  
  Point()
  {
    x = X;
    y = Y;
  }
  
  void update( float X, float Y )
  {
    x = X;
    y = Y;
  }
}
